//Code: Cruzer/CML 2018
//Asm: KickAss 4.19

.var tmp = $08

.pc = $0801 "basic"
:BasicUpstart(start)

.pc = $080d "main"

pixels:
	.fill 15, ((((i + 1) & 1) << 0) | (((i + 1) & 2) << 1) | (((i + 1) & 4) << 2) | (((i + 1) & 8) << 3)) << 1

start:
	sei
	lda #$d8
	sta $d016
	lda #$1e
	sta $d018
	sta $d021
	ldx #$00
cnt:	lsr $01

gfxLoop:

src:	lda $d000,x
mask:	and #%01111000
roll:	lsr
	lsr
	lsr
	tay
	lda pixels - 1,y
	tay
	lsr
	adc tmp
dest:	sta $3800,x
	sty tmp

	inx
	bne gfxLoop

	inc dest + 2
	lda src + 2
	eor #$01
	sta src + 2
	lsr
	bcs gfxLoop

	lda #%00000111
	sta mask + 1

	lda #ASL
	sta roll + 0
	sta roll + 1
	
	dec cnt + 1
	bpl gfxLoop


.var yPos = 15

setupLoop:
	txa
	lsr
	sta tmp
	ror
	alr #$80
	ora tmp
	sta $0400 + 40 * yPos,x
	lda #$3f
	sta $01
	sta $d800 + 40 * yPos,x
	inx
	bpl setupLoop

	cli
	rts
